#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

void die(const char* s) {
    printf("%s", s);
    exit(2);
}

#define MAX_DIM 15

typedef int board_square_t;

int main() {
    int m, n, error;
    board_square_t *board;

    printf("Please specify the board height: \n");
    error = scanf("%d", &m);
    if (EOF == error || m <= 0 || m > MAX_DIM) {
        die("Invalid height: Die evil hacker!\n");
    }

    printf("Please specify the board width: \n");
    error = scanf("%d", &n);
    if (EOF == error || n <= 0 || n > MAX_DIM) {
        die("Invalid width: Die evil hacker!\n");
    }

    if (m > INT_MAX / n) {
        die("Integer overflow detected: Die evil hacker!\n");
    }

    //@ split m;
    //@ split n;
    
    board = (board_square_t*) malloc(m * n * sizeof(board_square_t));
    if (!board) {
        return 2;
    }

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            board[n * i + j] = 0;
        }
    }

    if (board[(m - 1) * n] == 0) {
        free(board);
        return 0;
    } else {
        free(board);
        return 1;
    }
}
